import {Component, computed, input, signal, Signal} from '@angular/core';
import {User} from "../../User";
import {NgForOf} from "@angular/common";

@Component({
  selector: 'app-signal-search-result',
  standalone: true,
  imports: [
    NgForOf
  ],
  templateUrl: './result.component.html',
})
export class ResultComponent {
  search = input<string>('', {
    transform: (value) => value.toLowerCase()
  });

  matchingUsers: Signal<User[]> = computed(() => {
    return this.stuff.filter((user) => {
      return user.name.toLowerCase().includes(this.search().toLowerCase());
    });
  })

  readonly stuff: User[] = [
    {
      id: 1,
      name: 'John Doe',
      age: 20
    },
    {
      id: 2,
      name: 'Jane Doe',
      age: 22
    },
    {
      id: 3,
      name: 'Jack Doe',
      age: 25
    },
    {
      id: 4,
      name: 'Jill Doe',
      age: 28
    },
    {
      id: 5,
      name: 'Joe Doe',
      age: 30
    },
    {
      id: 6,
      name: 'Jim Doe',
      age: 35
    },
    {
      id: 7,
      name: 'Jerry Doe',
      age: 40
    },
    {
      id: 8,
      name: 'Jessie Doe',
      age: 45
    }
  ];

}
