import {ChangeDetectionStrategy, Component, signal} from '@angular/core';
import {JsonPipe, NgForOf, NgIf} from "@angular/common";
import {User} from "./User";
import {InputComponent} from "./search/input/input.component";
import {ResultComponent} from "./search/result/result.component";

@Component({
  selector: 'app-signal',
  standalone: true,
  imports: [
    JsonPipe,
    NgForOf,
    NgIf,
    InputComponent,
    ResultComponent
  ],
  templateUrl: './signal.component.html',
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class SignalComponent {
  a = signal<number>(2);
  b = signal<User>({id: 1, name: 'John Doe', age: 20});

  increaseA() {
    this.a.update((value) => value + 1);
  }

  increaseB() {
    this.b.update((value) => ({...value, age: value.age + 1}));
  }
}
